"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
var bunyan = require("bunyan");
var PrettyStream = require("bunyan-prettystream");
var pkg = require("./metadata");
var http = require("http");
var prettyStdOut = new PrettyStream();
prettyStdOut.pipe(process.stdout);
var Logger = /** @class */ (function (_super) {
    __extends(Logger, _super);
    function Logger() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    Logger.prototype.time = function (action, startTime) {
        var time = Date.now() - startTime;
        this.info({
            action: action,
            duration: time,
            type: "TIMER",
        }, "TIMER: " + action + " completed in " + time + " milliseconds");
    };
    Object.defineProperty(Logger.prototype, "logLevelName", {
        get: function () {
            return bunyan.nameFromLevel[this.level()];
        },
        enumerable: true,
        configurable: true
    });
    return Logger;
}(bunyan));
exports.Logger = Logger;
var logger = new Logger({
    name: "pact@" + pkg.version,
    streams: [
        {
            level: (process.env.LOGLEVEL || "info"),
            stream: prettyStdOut,
            type: "raw",
        },
    ],
});
exports.traceHttpInteractions = function () {
    var originalRequest = http.request;
    http.request = function (options, cb) {
        var requestBodyChunks = [];
        var responseBodyChunks = [];
        var hijackedCalback = function (res) {
            logger.trace("outgoing request", __assign(__assign({}, options), { body: Buffer.concat(requestBodyChunks).toString("utf8") }));
            if (cb) {
                return cb(res);
            }
        };
        var clientRequest = originalRequest(options, hijackedCalback);
        var oldWrite = clientRequest.write.bind(clientRequest);
        clientRequest.write = function (chunk) {
            requestBodyChunks.push(Buffer.from(chunk));
            return oldWrite(chunk);
        };
        clientRequest.on("response", function (incoming) {
            incoming.on("readable", function () {
                responseBodyChunks.push(Buffer.from(incoming.read()));
            });
            incoming.on("end", function () {
                logger.trace({
                    body: Buffer.concat(responseBodyChunks).toString("utf8"),
                    headers: incoming.headers,
                    statusCode: incoming.statusCode,
                });
            });
        });
        return clientRequest;
    };
};
exports.default = logger;
//# sourceMappingURL=logger.js.map